import * as stream from 'stream';
import * as httpm from './typed-rest-client/HttpClient';
import * as models from '../Models';
import { IRequestHandler, IRequestOptions } from './typed-rest-client/Interfaces';
import { ArtifactItemStore } from '../Store/artifactItemStore';
export declare class WebProvider implements models.IArtifactProvider {
    artifactItemStore: ArtifactItemStore;
    constructor(rootItemsLocation: any, templateFile: string, variables: any, handler: IRequestHandler, requestOptions?: IRequestOptions);
    getRootItems(): Promise<models.ArtifactItem[]>;
    getArtifactItems(artifactItem: models.ArtifactItem): Promise<models.ArtifactItem[]>;
    getArtifactItem(artifactItem: models.ArtifactItem): Promise<NodeJS.ReadableStream>;
    putArtifactItem(item: models.ArtifactItem, readStream: stream.Readable): Promise<models.ArtifactItem>;
    dispose(): void;
    private getItems(itemsUrl);
    private getTemplateFilePath();
    private extend(target, source);
    private rootItemsLocation;
    private templateFile;
    private variables;
    httpc: httpm.HttpClient;
}
