"use strict";
const httpm = require('./typed-rest-client/HttpClient');
const models = require('../Models');
const factory = require('./webClientFactory');
class ZipProvider {
    constructor(zipLocation, handler, requestOptions) {
        this.httpc = new httpm.HttpClient('artifact-engine');
        this.zipLocation = zipLocation;
        this.httpc = factory.WebClientFactory.getClient([handler], requestOptions);
    }
    getRootItems() {
        var rootItem = new models.ArtifactItem();
        rootItem.metadata = { downloadUrl: this.zipLocation };
        rootItem.path = '';
        rootItem.itemType = models.ItemType.File;
        return Promise.resolve([rootItem]);
    }
    getArtifactItems(artifactItem) {
        return null;
    }
    getArtifactItem(artifactItem) {
        var promise = new Promise((resolve, reject) => {
            if (!artifactItem.metadata || !artifactItem.metadata['downloadUrl']) {
                reject("No downloadUrl available to download the item.");
            }
            var downloadSize = 0;
            var itemUrl = artifactItem.metadata['downloadUrl'];
            itemUrl = itemUrl.replace(/([^:]\/)\/+/g, "$1");
            this.httpc.get(itemUrl).then((res) => {
                resolve(res.message);
            }, (reason) => {
                reject(reason);
            });
        });
        return promise;
    }
    putArtifactItem(artifactItem, stream) {
        return null;
    }
    dispose() {
    }
}
exports.ZipProvider = ZipProvider;
//# sourceMappingURL=zipProvider.js.map